#include <stdio.h>
#include <math.h>
double a8[8],b8[8];
double pi,cx,cy;
int    n1,n2;
FILE *fp;
main(int ac, char **av)
{
// 182, 70--->   (4096+182)*2, (4032+70)*2 --->8556, 8204;
// 25"    --->        55 pixel             --->8501, 8149;                  
  int  i,j,k;
  char h[72][80];
  float x,y,xx,yy;
  pi=4.*atan(1.0); cx=pi/12.; cy=pi/180.;
  n1=4096; n2=4032;
  if(ac<2){
     printf("\n\ta8b8 p*.fit *****\n");
     exit(0);
  }
  xx=yy=0;
  for(i=1;i<ac;i++){
    fp=fopen(av[i],"rb"); fread(h,72,80,fp); fclose(fp);
    k=indexpos(h,"A81     ",72);
    for(j=0;j<8;j++)sscanf(&h[k+j][11],"%le",&a8[j]);
    xytoad(a8,b8);
    x=b8[4]; y=b8[5];
    if(x>n1)x-=n1;
    if(y>n2)y-=n2;
    printf("%s %6.1f %6.1f\n",av[i],x,y);
    if(x<0)x=-x; if(y<0)y=-y;
    xx+=x; yy+=y;
  } k=ac-1;
  printf("******%7.1f%7.1f\n",xx/k,yy/k);
}
   
xytoad(x,a)
double *x,*a;
{
  double z;
  z=x[0]*x[3]-x[2]*x[1];
  a[0]= x[3]/z;
  a[1]=-x[1]/z;
  a[2]=-x[2]/z;
  a[3]= x[0]/z;
  a[4]= (x[2]*x[5]-x[4]*x[3])/z;
  a[5]= (x[4]*x[1]-x[0]*x[5])/z;
}

#define bok  48.
xy_rad(ac,dc,x,y,ra,de,type,k)
double ac,dc,x,y,*ra,*de;  int type,k;
{
  double xi,xn,tmp,tmp1;
  double x1,y1,r1,d1;
  int i;
  xi=a8[0]*x+a8[2]*y+a8[4];
  xn=a8[1]*x+a8[3]*y+a8[5];
  if(type==1){
    tmp=sqrt(xi*xi+xn*xn);
    if(tmp!=0.){
      tmp=tan(tmp)/tmp;
      xi*=tmp;  xn*=tmp;
    }
  }
  if(type==2){
    tmp=1.+bok*(xi*xi+xn*xn);

    for(i=0;i<4;i++){
      x1=xi/tmp; y1=xn/tmp;
      tmp=tan(dc);  tmp1=1.-y1*tmp;
      r1=atan(x1/cos(dc)/tmp1);
      d1=atan((y1+tmp)*cos(r1)/tmp1);
      r1+=ac;
      tmp=atan(tan(d1)/cos(r1-ac));
      x1=cos(tmp)*tan(r1-ac)/cos(tmp-dc);
      y1=tan(tmp-dc);
      tmp=1.+bok*(x1*x1+y1*y1);
    }
    xi/=tmp; xn/=tmp;
  }
  tmp=tan(dc);  tmp1=1.-xn*tmp;
  *ra=atan(xi/cos(dc)/tmp1);
  *de=atan((xn+tmp)*cos(*ra)/tmp1);
  *ra+=ac;
  tmp=(*de)-dc; if(tmp<0.)tmp=-tmp;
  if(tmp>2.){  *de=-(*de);  *ra+=pi; }
  if(*ra<0.)*ra+=(pi+pi);
  if(k==0){ *ra/=cx; *de/=cy; }
}
